<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
            <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
            <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
        <title>Task 23B.40</title>
    </head>
    <style>
        .background-image {
            background-image: url(LuckyDiceImages/ob_cd446b_black-bg-casinodice.jpg);
            min-height: 100px;
            margin: 5px;
        }
    </style>
    <body>
        <div class="container-fluid background-image">
            ImgDice
        </div>
        <div class="container">
            <div class="row">
                <div class="col-sm-5">
                    <div class="row">
                        <div class="col-sm-12 form-group">
                            <h4>
                                Nhập thông tin của bạn
                            </h4>
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-4">
                            <label for="input-username"> 
                                Username
                            </label>
                        </div>
                        <div class="col-sm-8">
                            <input id="input-username" type="text" class="form-control" type="text" placeholder="username....">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-4">
                            <label for="input-firstname"> 
                                Firstname
                            </label>
                        </div>
                        <div class="col-sm-8">
                            <input id="input-firstname" type="text" class="form-control" type="text" placeholder="firstname....">
                        </div>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-4">
                            <label for="input-lastname"> 
                                Lastname
                            </label>
                        </div>
                        <div class="col-sm-8">
                            <input id="input-lastname" type="text" class="form-control" type="text" placeholder="lastname....">
                        </div>
                    </div>
                </div>
                <div class="col-sm-4">
                    <div class="row">
                        <div class="col-sm-12 text-center">
                            <button class="btn btn-success" onclick="onBtnNemClick()">Ném</button>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-sm-12 text-center">
                            <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice_noun_002_10624.jpg" alt="">
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-sm-12 text-center">
                            <p id="p-thongbao">Xin Chào</p>
                        </div>
                    </div>
                </div>
                <div class="col-sm-3">
                    <div class="row">
                        <div class="col-sm-12 text-center form-group">
                            <p>
                                Voucher
                            </p>
                            <p id="p-id">
                                ID:0000
                            </p>
                            <p id="p-discount">
                                0%
                            </p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="co-sm-12 text-center form-group">
                            <img id="img-prize" src="LuckyDiceImages/no-present.jpg" class="img-thumbnail" alt="">
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12 text-center form-group">
                   <button onclick="onBtnDiceHistoryClick()" class="btn btn-success">Dice Hitory</button>
                   <button onclick="onBtnVoucherHistoryClick()" class="btn btn-info">Voucher Hitory</button>
                   <button onclick="onBtnPresentHistoryClick()" class="btn btn-info">Presnet Hitory</button>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                   <table id="history-placeholder-table" class="table table-striped table-hover ">
                       <thead>
                        <tr>
                            <th>
                                Lượt
                            </th>
                            <th>
                                Dice
                            </th>
                        </tr>
                       </thead>
                       <tbody>
                       </tbody>
                   </table>
                </div>
            </div>
        </div>
    </body>
    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //Hàm xữ lý nút ném
        function onBtnNemClick() {
            "use strict";
            //Dùng hàm getDataFormInput truyền dữ liệu input vào UserDataObject
            var vUserDataObject = getDataFormInput();
            // Hàm kiểm tra thông tin input xem có hợp lệ ko nếu hợp lệ thì trả  vCHeckvề true còn không thì cảnh báo và trả vCHeck về false
            var vCHeck = validateDaTaObject(vUserDataObject);
            console.log(vCHeck);
            //Nếu vCheck = true thì consolelog ra "Dữ liệu hợp lệ" nếu false thì consolelog ra "Dữ liệu không hợp lệ"
            if (vCHeck == true) {
                console.log("Dữ liệu hợp lệ");
                //Gọi server lấy responseText ghi ra console.log
                callAPIDataDice(vUserDataObject);
            } else{
                console.log("Dữ liệu không hợp lệ");
            }
        }
        //Hàm nút nhấn Dice History
        function onBtnDiceHistoryClick() {
            "use strict"
            console.log("Nút Dice History được ấn");
             //Dùng hàm getDataFormInput truyền dữ liệu input vào UserDataObject
             var vUserDataObject = getDataFormInput();
            // Hàm kiểm tra thông tin input xem có hợp lệ ko nếu hợp lệ thì trả  vCHeckvề true còn không thì cảnh báo và trả vCHeck về false
            var vCHeck = validateDaTaObject(vUserDataObject);
            if (vCHeck == true) {
                console.log("Dữ liệu hợp lệ");
                //Gọi server lấy responseText ghi ra console.log
                callAPIDataHistoryDice(vUserDataObject);
            } else{
                console.log("Dữ liệu không hợp lệ");
            }
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //Hàm xóa hết phần tử row trong mảng 
        function refreshDiceHistoryTable() {
            "use strict"
            var vTable = document.getElementById("history-placeholder-table");
            while (vTable.rows.length > 1) {
                vTable.deleteRow(1);
            }
        }
        
        //Hàm ghi già trị dice history ra table
         function writeObjectDiceHistoryToTable(vDiceHistoryObject) {
            "use strict";
            const vEND_OF_ROW = -1;
            const vCOLUMM_OF_TURN = 0;
            const vCOLUMM_OF_DICE = 1;
            var vTableDiceHistoryElement = document.getElementById("history-placeholder-table");
            var vTable = vTableDiceHistoryElement.getElementsByTagName("tbody")[0];
            var vDiceHistory = vDiceHistoryObject.dices;
            for (var bIndex = 0 ; bIndex < vDiceHistory.length; bIndex ++) {
                var vRow = vTable.insertRow(vEND_OF_ROW);
                var vCellTurn = vRow.insertCell(vCOLUMM_OF_TURN);
                var vCellDice = vRow.insertCell(vCOLUMM_OF_DICE);
                vCellTurn.innerHTML = bIndex + 1;
                vCellDice.innerHTML = vDiceHistory[bIndex];
            }
         }

        //Hàm onReadyStateChange của dice history
        function onReadyStateChangeDiceHIstory (paramXMLHttpDiceHistory) {
            "use strict";
            var vXmlHttpDiceHistory = paramXMLHttpDiceHistory;
            vXmlHttpDiceHistory.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vResponse = vXmlHttpDiceHistory.responseText;
                    //Ghi ra consolelog object vResponse dưới dạng string
                    console.log(vResponse);
                    //Chuyển vResponse dưới dang string thành object và gán vào vDiceHistoryObject
                    var vDiceHistoryObject = JSON.parse(vResponse);
                    //Ghi ra console.log vDiceHistoryObject
                    console.log(vDiceHistoryObject);
                    //Xóa hết phần tử row trong mảng
                    refreshDiceHistoryTable();
                    //Ghi già trị dice history ra table
                    writeObjectDiceHistoryToTable(vDiceHistoryObject);
                }
            }
        }
        //Hàm api ibject dạng text của dice history
        function callAPIDataHistoryDice(paramDataObject) {
            "use strict";
            const vBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice";
            var vUserNameTest = paramDataObject.username;

            var vXmlHttpDiceHistory = new XMLHttpRequest();
            vXmlHttpDiceHistory.open("GET", vBASE_URL + "/dice-history?username=" + vUserNameTest, true);
            vXmlHttpDiceHistory.send();
            onReadyStateChangeDiceHIstory(vXmlHttpDiceHistory);
        }
        //Hiển thị prizes nếu có
        function changePrizesPresent (paramPrize) {
            "use strict";
            var vImgPrizeElement = document.getElementById("img-prize");
            var vPrize = paramPrize;
            switch(vPrize) {
                case "Mũ":
                    vImgPrizeElement.src = "LuckyDiceImages/hat.jpg";
                    break;
                case "Áo":
                    vImgPrizeElement.src = "LuckyDiceImages/t-shirt.png";
                    break;
                case "Ô tô":
                    vImgPrizeElement.src = "LuckyDiceImages/car.jpg";
                    break; 
                case "Xe máy":
                    vImgPrizeElement.src = "LuckyDiceImages/xe_may.png";
                    break;
                default:
                    vImgPrizeElement.src = "LuckyDiceImages/no-present.jpg";
            }
        }
        
        //Hàm ghi ra voucher
        function changeVoucherID (paramVoucher, paramDIceObject) {
            "use strict";
            var vPVoucherIdElement = document.getElementById("p-id");
            var vPVoucherDiscountElement = document.getElementById("p-discount");
            var vVoucher = paramVoucher;
            if (vVoucher == null) {
                vPVoucherIdElement.innerHTML = "ID:0000"
                vPVoucherDiscountElement.innerHTML = "0%"
            } else {
                var vVoucherId = paramDIceObject.voucher.maVoucher;
                var vVoucherDiscount = paramDIceObject.voucher.phanTramGiamGia;
                vPVoucherIdElement.innerHTML = "ID:" +vVoucherId
                vPVoucherDiscountElement.innerHTML = vVoucherDiscount + "%"
            }
        }

        //Hàm ghi ra thông báo
        function changeNotification(paramDIce){
            "use strict";
            var vPNotification = document.getElementById("p-thongbao");
            if (paramDIce < 4) {
                vPNotification.innerHTML = "Chúc bạn may mắn lần sau !!!";
            } else {
                vPNotification.innerHTML = "Xin chúc bạn hãy chơi tiếp !!!";
            }
        }
        
        //Hàm chuyển đổi ảnh dựa vào số xúc xắc
        function changeImgDiceWithResult(paramDiceObject) {
            "use strict";
            var vImgDiceElement = document.getElementById("img-dice");
            var vDice = paramDiceObject;
            if (vDice == 1) {
                vImgDiceElement.src = "LuckyDiceImages/1.png";
            } else  if (vDice == 2) {
                vImgDiceElement.src = "LuckyDiceImages/2.png";
            } else  if (vDice == 3) {
                vImgDiceElement.src = "LuckyDiceImages/3.png";
            } else  if (vDice == 4) {
                vImgDiceElement.src = "LuckyDiceImages/4.png";
            } else  if (vDice == 5) {
                vImgDiceElement.src = "LuckyDiceImages/5.png";
            } else  if (vDice == 6) {
                vImgDiceElement.src = "LuckyDiceImages/6.png";
            }
        }
        //Hàm chuyển giá trị Object dạng text sang Object
        function changeResponseTextToOBject(paramXMLHttp) {
            "use strict";
            var  vDiceObject = JSON.parse(paramXMLHttp.responseText);
            return vDiceObject;
        }

        // Hàm kiểm tra thông sô status
        function onReadyStateChangeDice (paramXMLHttp) {
            "use strict";
            var vXMLHttpDice = paramXMLHttp;
            vXMLHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                writeResponseTextToConsoleLog(vXMLHttpDice);
                //Hàm chuyển giá trị Object dạng text sang Object
                var vDiceObject = changeResponseTextToOBject(vXMLHttpDice);
                 //Ghi ra object vDiceObject
                console.log(vDiceObject);
                //chuyển đổi ảnh dựa vào số xúc xắc
                var vDice = vDiceObject.dice;
                changeImgDiceWithResult(vDice);
                //ghi ra thông báo
                changeNotification(vDice);
                //Hiển thị ra voucher(nếu có)
                var vVoucher = vDiceObject.voucher;
                changeVoucherID(vVoucher , vDiceObject);
                //Hiển thị prizes nếu có
                var vPrize = vDiceObject.prize;
                changePrizesPresent(vPrize);
                }
            }
        }
        // Hàm ghi data ra consolelog
        function writeResponseTextToConsoleLog (paramXMLHttp) {
            "use strict";
            console.log(paramXMLHttp.responseText);
        }

        //Gọi server lấy responseText
        function callAPIDataDice(paramDataObject) {
            "use strict";
            const vBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
            const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
            // create a request
            var vXMLHttpDice = new XMLHttpRequest();
            vXMLHttpDice.open("POST", vBASE_URL + "/dice" ,true);
            vXMLHttpDice.setRequestHeader("content-Type", vUTF8_TEXT_APPLICATION_HEADER);
            vXMLHttpDice.send(JSON.stringify(paramDataObject));//chuyển Json object sang string
            //kiểm tra thông số status và thông số ready status finish 
            onReadyStateChangeDice(vXMLHttpDice);
        }
        //Hàm kiểm tra dữ liệu
        function validateDaTaObject(paramDataObject) {
            "use strict";
            var vResult = true;
            var vUsername = paramDataObject.username.trim();
            var vFirstname = paramDataObject.firstname.trim();
            var vLastname = paramDataObject.lastname.trim();
            if (vUsername == "") {
                alert("Chưa nhập username");
                vResult = false;
            } else if (vFirstname == "") {
                alert("Chưa nhập firstname");
                vResult = false;
            } else if ( vLastname == "") {
                alert("Chưa nhập lastname");
                vResult = false;
            }
            return vResult;
        }

        //Hàm lấy thông tin input chuyền vào hướng đối tượng vUserDataObject
        function getDataFormInput() {
            "use strict";
            var vUserDataObject = {
                username: "",
                firstname: "",
                lastname: ""
            }
            var vInputUsernameElemnent = document.getElementById("input-username");
            var vInputFirstnameElemnent = document.getElementById("input-firstname");
            var vInputLastnameElemnent = document.getElementById("input-lastname");
            vUserDataObject.username = vInputUsernameElemnent.value;
            vUserDataObject.firstname = vInputFirstnameElemnent.value;
            vUserDataObject.lastname = vInputLastnameElemnent.value;
            return vUserDataObject;
        }
    </script>
</html>